" NOTE: gvim -U i-cmd.vim
"
" Save options
:let s:cpo_save = &cpo
:set cpo&vim

"
" Define a function to put in the #include stuff
"
:function! Include()
:   " Get the current line
:   let l:line = getline(".")

:   " Put the #include in the right place
:   let l:line = "#include <".l:line.">"

:   " Replace the line
:   call setline(".", l:line)
:endfunction


" Simple test function
:function! Test(x1, x2)
:   echo a:x1." XX ".a:x2
:   call getchar()
:endfunction

:command! -nargs=0 -range TestIt :call Test(<line1>, <line2>)

"
" Call Include over a range of lines
"
:function! IncludeRange(first_line, last_line)
:    let l:cur_line = a:first_line
:
:    while (l:cur_line <= a:last_line) 
:        call setpos('.', [0, l:cur_line, 0, 0])
:	 call Include()
" Debug stuff
:echo l:cur_line
:redraw
:sleep 5
:        let l:cur_line = l:cur_line + 1
:    endwhile
:endfunction

:command! -nargs=0 -range Include :call IncludeRange(<line1>, <line2>)

:command! -nargs=0 -range Include2 :<line1>, <line2>call Include()

" Now generate a way of calling the function
:map <F11> :call Include()<CR>

"NOTE: Define something in the menu
:menu 40.290 &Tools.&Include<tab>:call\ Include() :call Include()<CR>

"NOTE: Make it work for all modes
:amenu 40.295 &Tools.&Include(a)<tab>:call\ Include() :call Include()<CR>

" NOTE: Define something in the top level menu
:amenu 30 &C-Tools.Include :call Include()<CR>

"NOTE: Add it to the popup menu (mouse model)
:amenu 1.5 PopUp.&Include<tab>:call\ Include() :call Include()<CR>

"NOTE: Put it in the toolbar
:amenu icon=/home/sdo/vim/include/include.xpm 1.1 ToolBar.Include :call Include()<CR>
:tmenu ToolBar.Include Put in the #include line

"Enable or disable the menu depending on file type
:function! CMenuCheck()
:    if (&ft == "c") || (&ft == "cpp")
:       menu enable &C-Tools
:    else
:       menu disable &C-Tools
:    endif
:endfunction

"Automatically call the menu when we enter a buffer or the file type changes
:autocmd Bufenter * :call CMenuCheck()
:autocmd FileType * :call CMenuCheck()

:filetype on
" Restore the previous value of 'cpoptions'.
:let &cpo = s:cpo_save
:unlet s:cpo_save
:source ~/.gvimrc
