" NOTE: Start with gvim -U i-fancy.vim
" Save options
:let s:cpo_save = &cpo
:set cpo&vim
"
" Configuration section follow
"
" System include directories
:let g:SystemIncludes = [
\    "/usr/include", 
\    "/usr/include/gnu", 
\    "/usr/include/net", 
\    "/usr/include/linux", 
\    "/usr/include/sys", 
\    "/usr/include/c++/3.4.3"
\]

" Local includes follow
:let g:LocalIncludes = [
\	".",
\	"include"
\]
"
" Define a function to put in the #include stuff
"
:function! Include()
:    " Get the current line
:    let l:line = getline(".")
:
:    " Loop through the local directories looking for the file
:    for l:cur_dir in g:LocalIncludes
:       if (filereadable(l:cur_dir."/".l:line)) 
:	    " Put the #include in the right place
:           let l:line = "#include \"".l:line."\""
:           call setline(".", l:line)
:           return
:       endif
:    endfor
:     
:    " Loop through the system directories looking for the file
:    for l:cur_dir in g:SystemIncludes
:       if (filereadable(l:cur_dir."/".l:line)) 
:	    " Put the #include in the right place
:           let l:line = "#include <".l:line.">"
:           call setline(".", l:line)
:           return
:       endif
:    endfor

:    " Put in a default #include
:    let l:line = "#include \"".l:line."\" // WARNING: Can not locate include"

:   " Replace the line
:   call setline(".", l:line)
:endfunction

" Now generate a way of calling the function
:map <F11> :call Include()<CR>

:filetype on
" Restore the previous value of 'cpoptions'.
:let &cpo = s:cpo_save
:unlet s:cpo_save
:source ~/.gvimrc
